## -----------------------------------------------------------------------------
## ------------------------------ ERROR CLASSES --------------------------------
## -----------------------------------------------------------------------------
    
## derived from Exception ------------------------------------------------------
class Error(Exception):
    def __init__(self, reas, desc, num):
        Exception.__init__(self)
        self.reason = reas
        self.description = desc
        self.number = num
        
## derived from Error ----------------------------------------------------------
class ErrObject(Error):
    def __init__(self, reason, description, number=0):
        Error.__init__(self, reason, description, number)
class ErrAttribute(Error):
    def __init__(self, reason, description, number=0):
        Error.__init__(self, reason, description, number)
class ErrSearch(Error):
    def __init__(self, reason, description, number=0):
        Error.__init__(self, reason, description, number)
        
## -----------------------------------------------------------------------------
## -----------------------------------------------------------------------------

## derived from ErrObject ------------------------------------------------------
class ErrObjectLocking(ErrObject):
    def __init__(self, reason, description, number=0):
        ErrObject.__init__(self, reason, description, number)
class ErrObjectUnlocking(ErrObject):
    def __init__(self, reason, description, number=0):
        ErrObject.__init__(self, reason, description, number)
class ErrObjectReading(ErrObject):
    def __init__(self, reason, description, number=0):
        ErrObject.__init__(self, reason, description, number)
class ErrObjectConstruction(ErrObject):
    def __init__(self, reason, description, number=0):
        ErrObject.__init__(self, reason, description, number)

## derived from ErrAttribute ---------------------------------------------------
class ErrAttributeChanging(ErrAttribute):
    def __init__(self, reason, description, number=0):
        ErrAttribute.__init__(self, reason, description, number)
class ErrAttributeValue(ErrAttribute):
    def __init__(self, reason, description, number=0):
        ErrAttribute.__init__(self, reason, description, number)
        
## derived from ErrSearch ---------------------------------------------------
class ErrSearchParameter(ErrSearch):
    def __init__(self, reason, description, number=0):
        ErrSearch.__init__(self, reason, description, number)
class ErrSearchDBtype  (ErrSearch):
    def __init__(self, reason, description, number=0):
        ErrSearch.__init__(self, reason, description, number)
class ErrSearchResult  (ErrSearch):
    def __init__(self, reason, description, number=0):
        ErrSearch.__init__(self, reason, description, number)

## -----------------------------------------------------------------------------
## -----------------------------------------------------------------------------
        
## derived from ErrObjectLocking -----------------------------------------------
class ErrObjLockedFromMe(ErrObjectLocking):
    def __init__(self, reason, description, number=0):
        ErrObjectLocking.__init__(self, reason, description, number)
class ErrObjNotLockable(ErrObjectLocking):
    def __init__(self, reason, description, number=0):
        ErrObjectLocking.__init__(self, reason, description, number)
        
## derived from ErrObjectUnlocking ---------------------------------------------
class ErrObjNotLockedFromMe(ErrObjectUnlocking):
    def __init__(self, reason, description, number=0):
        ErrObjectUnlocking.__init__(self, reason, description, number)
class ErrObjWasNotLocked(ErrObjectUnlocking):
    def __init__(self, reason, description, number=0):
        ErrObjectUnlocking.__init__(self, reason, description, number)

## derived from ErrObjectReading -----------------------------------------------
class ErrObjIDnotFound(ErrObjectReading):
    def __init__(self, reason, description, number=0):
        ErrObjectReading.__init__(self, reason, description, number)
 
## -----------------------------------------------------------------------------
## -----------------------------------------------------------------------------

## derived from ErrAttributeChanging -------------------------------------------
class ErrAttrIncorrectTypeOrName(ErrAttributeChanging):
    def __init__(self, reason, description, number=0):
        ErrAttributeChanging.__init__(self, reason, description, number)
class ErrAttrNotDeleted(ErrAttributeChanging):
    def __init__(self, reason, description, number=0):
        ErrAttributeChanging.__init__(self, reason, description, number)
class ErrAttrTableChange(ErrAttributeChanging):
    def __init__(self, reason, description, number=0):
        ErrAttributeChanging.__init__(self, reason, description, number)
